
#CREATE DATABASE db_dipendente;

#USE db_dipendente;

CREATE TABLE Dipendente
(
  Codice        INT(4)                      NOT NULL  AUTO_INCREMENT,
  Cognome       VARCHAR(50)                 NOT NULL,
  Nome          VARCHAR(50)                 NOT NULL,
  Stipendio     DECIMAL(6,2)                NOT NULL,
  Livello       ENUM ('6', '7', '8', '9')   NOT NULL DEFAULT '6',
  PRIMARY KEY (Codice),  
  CHECK (Stipendio BETWEEN 900 AND 1200)    #se non si definisce un TRIGGER non verrà controllato
) Engine InnoDB DEFAULT CHARSET=utf8;

#
# Dumping data for table Dipendente
#
INSERT INTO Dipendente (Codice, Cognome, Nome, Stipendio, Livello)
		VALUES (1, 'Costanzo', 'Renato', '1200.00', '7');

INSERT INTO Dipendente (Codice, Cognome, Nome, Stipendio, Livello)
		VALUES (2, 'Marini', 'Valeria', '950.00', '8');

INSERT INTO Dipendente (Codice, Cognome, Nome, Stipendio, Livello)
		VALUES (3, 'Costanzo', 'Maurizio','1150.00', '8');

INSERT INTO Dipendente (Codice, Cognome, Nome, Stipendio, Livello)
		VALUES (4, 'Verstappen', 'Max', '1010.00', '9');

#
# Dumping TRIGGER trg_Stipendio
#
DELIMITER //
CREATE TRIGGER trg_Stipendio
BEFORE INSERT ON db_dipendente.Dipendente
FOR EACH ROW
BEGIN
DECLARE msg VARCHAR(255);
IF NEW.Stipendio < 900.00
   THEN
       SET msg = concat("Lo stipendio non puo' essere inferiore a 900.00 euro");
       SIGNAL sqlstate '45000' SET message_text = msg;
   ELSE
	   IF NEW.Stipendio > 1200.00
          THEN
             SET msg = concat("Lo stipendio non puo' essere maggiore di 1200.00 euro");
             SIGNAL sqlstate '45000' SET message_text = msg;
       END IF;
END IF;
END//
DELIMITER ;
